import App
import Bridge.BridgeUtils
import MissionLib


def DialogoKlingon1():

	# Get Player
	pPlayer = MissionLib.GetPlayer()
	if pPlayer is None:
		return 0

	HailLines = ["HailOpen1","HailOpen2","OnScreen" ]
	rHailLines = App.g_kSystemWrapper.GetRandomNumber(len(HailLines))
	# Klingon bridge with Captain Draxon
	MissionLib.SetupBridgeSet("KlingonSet", "data/Models/Sets/Klingon/BOPbridge.nif", -30, 65, -1.55)
	MissionLib.SetupCharacter("Bridge.Characters.Draxon", "KlingonSet", 0, 0, -5)
	g_pMissionDatabase = App.g_kLocalizationManager.Load("data/TGL/Maelstrom/Episode 2/E2M6.tgl")
	KlingonSet = App.g_kSetManager.GetSet("KlingonSet")
	pDraxon = App.CharacterClass_GetObject(KlingonSet, "Draxon")
	# Get Helm character.
	pSet = App.g_kSetManager.GetSet("bridge")
	pHelm = App.CharacterClass_GetObject(pSet, "Helm")
	# Play dialogue.
	# Setup a sequence.
	pSeq = App.TGSequence_Create()
	pSeq.AppendAction(App.CharacterAction_Create(pHelm, App.CharacterAction.AT_PLAY_ANIMATION, "PushingButtons"))
	pLineAction = App.CharacterAction_Create(pHelm, App.CharacterAction.AT_SAY_LINE, HailLines[rHailLines],	None, 0, pHelm.GetDatabase())
	pSeq.AppendAction(pLineAction)

	# Inizia la visione sullo schermo.
	pSeq.AppendAction(App.TGScriptAction_Create("MissionLib", "ViewscreenOn", "KlingonSet", "Draxon"))

# --------------------------------------------------------------------

	# avvia il parlato.
	pSeq.AppendAction(Bridge.BridgeUtils.MakeCharacterLine(pDraxon, "E2M6FiresKlingon2", g_pMissionDatabase))       

# --------------------------------------------------------------------

	# Termina la visione sullo schermo.
	pSeq.AppendAction(App.TGScriptAction_Create("MissionLib", "ViewscreenOff"))

	MissionLib.QueueActionToPlay(pSeq)
	return 1


def DialogoRomulan1():
	# Get Player
	pPlayer = MissionLib.GetPlayer()
	if pPlayer is None:
		return 0

	HailLines = ["HailOpen1","HailOpen2","OnScreen" ]
	rHailLines = App.g_kSystemWrapper.GetRandomNumber(len(HailLines))

	# Romulan set with V'Lin
	MissionLib.SetupBridgeSet("RomulanSet", "data/Models/Sets/Romulan/romulanbridge.nif", -40, 65, -1.55, 0, -280, 0)
	MissionLib.SetupCharacter("Bridge.Characters.Torenn", "RomulanSet", 0, 0, 1)

	g_pMissionDatabase = App.g_kLocalizationManager.Load("data/TGL/Maelstrom/Episode 3/E3M4.tgl")
	RomulanSet = App.g_kSetManager.GetSet("RomulanSet")
	pRomulan = App.CharacterClass_GetObject(RomulanSet, "Torenn")

	# Get Helm character.
	pSet = App.g_kSetManager.GetSet("bridge")
	pHelm = App.CharacterClass_GetObject(pSet, "Helm")

	# Play dialogue.
	# Setup a sequence.
	pSeq = App.TGSequence_Create()
	pSeq.AppendAction(App.CharacterAction_Create(pHelm, App.CharacterAction.AT_PLAY_ANIMATION, "PushingButtons"))
	pLineAction = App.CharacterAction_Create(pHelm, App.CharacterAction.AT_SAY_LINE, HailLines[rHailLines],	None, 0, pHelm.GetDatabase())
	pSeq.AppendAction(pLineAction)

	# Inizia la visione sullo schermo.
	pSeq.AppendAction(App.TGScriptAction_Create("MissionLib", "ViewscreenOn", "RomulanSet", "Torenn"))

# --------------------------------------------------------------------

	# avvia il parlato
	pSeq.AppendAction(App.CharacterAction_Create(pRomulan, App.CharacterAction.AT_SAY_LINE, "E3M4PrepareToDie", None, 0, g_pMissionDatabase))

# --------------------------------------------------------------------

	# Termina la visione sullo schermo.
	pSeq.AppendAction(App.TGScriptAction_Create("MissionLib", "ViewscreenOff"))

	MissionLib.QueueActionToPlay(pSeq)
	return 1


def DialogoStarBaseLiu1():
	# Get Player
	pPlayer = MissionLib.GetPlayer()
	if pPlayer is None:
		return 0

	HailLines = ["HailOpen1","HailOpen2","OnScreen" ]
	rHailLines = App.g_kSystemWrapper.GetRandomNumber(len(HailLines))

	# Starbase set with Liu
	MissionLib.SetupBridgeSet("StarbaseSet", "data/Models/Sets/StarbaseControl/starbasecontrolRM.nif", -30, 65, -1.55)
	MissionLib.SetupCharacter("Bridge.Characters.Admiral_Liu", "StarbaseSet", 0, 0, 5)

	g_pMissionDatabase = App.g_kLocalizationManager.Load("data/TGL/Maelstrom/Episode 2/E2M1.tgl")
	StarbaseSet = App.g_kSetManager.GetSet("StarbaseSet")
	pLiu = App.CharacterClass_GetObject(StarbaseSet, "Liu")

	# Get Helm character.
	pSet = App.g_kSetManager.GetSet("bridge")
	pHelm = App.CharacterClass_GetObject(pSet, "Helm")

	# Play dialogue.	
	# Setup a sequence.
	pSeq = App.TGSequence_Create()
	pSeq.AppendAction(App.CharacterAction_Create(pHelm, App.CharacterAction.AT_PLAY_ANIMATION, "PushingButtons"))
	pLineAction = App.CharacterAction_Create(pHelm, App.CharacterAction.AT_SAY_LINE, HailLines[rHailLines],	None, 0, pHelm.GetDatabase())
	pSeq.AppendAction(pLineAction)

	# Inizia la visione sullo schermo.
	pSeq.AppendAction(App.TGScriptAction_Create("MissionLib", "ViewscreenOn", "StarbaseSet", "Liu"))

# --------------------------------------------------------------------

	# avvia il parlato
	pSeq.AppendAction(App.CharacterAction_Create(pLiu, App.CharacterAction.AT_SAY_LINE, "E2M1HailLiu1", None, 0, g_pMissionDatabase))

# --------------------------------------------------------------------

	# Termina la visione sullo schermo.
	pSeq.AppendAction(App.TGScriptAction_Create("MissionLib", "ViewscreenOff"))

	MissionLib.QueueActionToPlay(pSeq)
	return 1


def DialogoGalaxyVerata1():
	# Get Player
	pPlayer = MissionLib.GetPlayer()
	if pPlayer is None:
		return 0

	HailLines = ["HailOpen1","HailOpen2","OnScreen" ]
	rHailLines = App.g_kSystemWrapper.GetRandomNumber(len(HailLines))

	# DBridge set with Verata
	MissionLib.SetupBridgeSet("DBridgeSet", "data/Models/Sets/DBridge/DBridge.nif", -40, 65, -1.55)
	MissionLib.SetupCharacter("Bridge.Characters.Verata", "DBridgeSet")

	g_pMissionDatabase = App.g_kLocalizationManager.Load("data/TGL/Maelstrom/Episode 2/E2M0.tgl")
	DBridgeSet = App.g_kSetManager.GetSet("DBridgeSet")
	pVerata = App.CharacterClass_GetObject(DBridgeSet, "Verata")

	# Get Helm character.
	pSet = App.g_kSetManager.GetSet("bridge")
	pHelm = App.CharacterClass_GetObject(pSet, "Helm")

	# Play dialogue.	
	# Setup a sequence.
	pSeq = App.TGSequence_Create()
	pSeq.AppendAction(App.CharacterAction_Create(pHelm, App.CharacterAction.AT_PLAY_ANIMATION, "PushingButtons"))
	pLineAction = App.CharacterAction_Create(pHelm, App.CharacterAction.AT_SAY_LINE, HailLines[rHailLines],	None, 0, pHelm.GetDatabase())
	pSeq.AppendAction(pLineAction)

	# Inizia la visione sullo schermo.
	pSeq.AppendAction(App.TGScriptAction_Create("MissionLib", "ViewscreenOn", "DBridgeSet", "Verata", 0, 0, 0))

# --------------------------------------------------------------------

	# avvia il parlato
	pSeq.AppendAction(App.CharacterAction_Create(pVerata, App.CharacterAction.AT_SAY_LINE, "E2M0ZhukovEnters1", None, 0, g_pMissionDatabase))


# --------------------------------------------------------------------

	# Termina la visione sullo schermo.
	pSeq.AppendAction(App.TGScriptAction_Create("MissionLib", "ViewscreenOff"))

	MissionLib.QueueActionToPlay(pSeq)
	return 1



def DialogoSovereignPicard1():
	# Get Player
	pPlayer = MissionLib.GetPlayer()
	if pPlayer is None:
		return 0

	HailLines = ["HailOpen1","HailOpen2","OnScreen" ]
	rHailLines = App.g_kSystemWrapper.GetRandomNumber(len(HailLines))

	# The Sovereign bridge with Captain Picard
	MissionLib.SetupBridgeSet("EBridgeSet", "data/Models/Sets/EBridge/EBridge.nif", -40, 65, -1.55)
	MissionLib.SetupCharacter("Bridge.Characters.Picard", "EBridgeSet")

	g_pMissionDatabase = App.g_kLocalizationManager.Load("data/TGL/Maelstrom/Episode 7/E7M1.tgl")
	EBridgeSet = App.g_kSetManager.GetSet("EBridgeSet")
	pPicard = App.CharacterClass_GetObject(EBridgeSet, "Picard")

	# Get Helm character.
	pSet = App.g_kSetManager.GetSet("bridge")
	pHelm = App.CharacterClass_GetObject(pSet, "Helm")

	# Play dialogue.
	# Setup a sequence.
	pSeq = App.TGSequence_Create()
	pSeq.AppendAction(App.CharacterAction_Create(pHelm, App.CharacterAction.AT_PLAY_ANIMATION, "PushingButtons"))
	pLineAction = App.CharacterAction_Create(pHelm, App.CharacterAction.AT_SAY_LINE, HailLines[rHailLines],	None, 0, pHelm.GetDatabase())
	pSeq.AppendAction(pLineAction)


	# Inizia la visione sullo schermo.
	pSeq.AppendAction(App.TGScriptAction_Create("MissionLib", "ViewscreenOn", "EBridgeSet", "Picard"))

# --------------------------------------------------------------------
	rSth = App.g_kSystemWrapper.GetRandomNumber(6)

	# avvia il parlato
	if(rSth == 0):
		pSeq.AppendAction(App.CharacterAction_Create(pPicard, App.CharacterAction.AT_SAY_LINE, "E7M1PicardArrive1", None, 0, g_pMissionDatabase))
	if(rSth == 1):
		pSeq.AppendAction(App.CharacterAction_Create(pPicard, App.CharacterAction.AT_SAY_LINE, "E7M1PicardArrive2", None, 0, g_pMissionDatabase))
	if(rSth == 2):
		pSeq.AppendAction(App.CharacterAction_Create(pPicard, App.CharacterAction.AT_SAY_LINE, "E7M1PicardArrive3", None, 0, g_pMissionDatabase))
	if(rSth == 3):
		pSeq.AppendAction(App.CharacterAction_Create(pPicard, App.CharacterAction.AT_SAY_LINE, "E7M1PicardArrive4", None, 0, g_pMissionDatabase))
	if(rSth == 4):
		pSeq.AppendAction(App.CharacterAction_Create(pPicard, App.CharacterAction.AT_SAY_LINE, "E7M1PicardArrive5", None, 0, g_pMissionDatabase))
	if(rSth == 5):
		pSeq.AppendAction(App.CharacterAction_Create(pPicard, App.CharacterAction.AT_SAY_LINE, "E7M1PicardArrive6", None, 0, g_pMissionDatabase))


# --------------------------------------------------------------------

	# Termina la visione sullo schermo.
	pSeq.AppendAction(App.TGScriptAction_Create("MissionLib", "ViewscreenOff"))

	MissionLib.QueueActionToPlay(pSeq)
	return 1  



def DialogoGalaxyZeiss1():
	# Get Player
	pPlayer = MissionLib.GetPlayer()
	if pPlayer is None:
		return 0

	HailLines = ["HailOpen1","HailOpen2","OnScreen" ]
	rHailLines = App.g_kSystemWrapper.GetRandomNumber(len(HailLines))

	# The Sovereign bridge with Captain Zeiss
	MissionLib.SetupBridgeSet("DBridgeSet", "data/Models/Sets/DBridge/DBridge.nif", -40, 65, -1.55)
	MissionLib.SetupCharacter("Bridge.Characters.Zeiss", "DBridgeSet")

	g_pMissionDatabase = App.g_kLocalizationManager.Load("data/TGL/Maelstrom/Episode 1/E1M1.tgl")
	DBridgeSet = App.g_kSetManager.GetSet("DBridgeSet")
	pZeiss = App.CharacterClass_GetObject(DBridgeSet, "Zeiss")

	# Get Helm character.
	pSet = App.g_kSetManager.GetSet("bridge")
	pHelm = App.CharacterClass_GetObject(pSet, "Helm")

	# Play dialogue.	
	# Setup a sequence.
	pSeq = App.TGSequence_Create()
	pSeq.AppendAction(App.CharacterAction_Create(pHelm, App.CharacterAction.AT_PLAY_ANIMATION, "PushingButtons"))
	pLineAction = App.CharacterAction_Create(pHelm, App.CharacterAction.AT_SAY_LINE, HailLines[rHailLines],	None, 0, pHelm.GetDatabase())
	pSeq.AppendAction(pLineAction)


	# Inizia la visione sullo schermo.
	pSeq.AppendAction(App.TGScriptAction_Create("MissionLib", "ViewscreenOn", "DBridgeSet", "Zeiss", 0, 0, 0))

# --------------------------------------------------------------------

	# avvia il parlato
	pSeq.AppendAction(App.CharacterAction_Create(pZeiss, App.CharacterAction.AT_SAY_LINE, "E1M1HailSF1", None, 0, g_pMissionDatabase))


# --------------------------------------------------------------------

	# Termina la visione sullo schermo.
	pSeq.AppendAction(App.TGScriptAction_Create("MissionLib", "ViewscreenOff"))

	MissionLib.QueueActionToPlay(pSeq)
	return 1



def DialogoBorg1():
	# Get Player
	pPlayer = MissionLib.GetPlayer()
	if pPlayer is None:
		return 0

	HailLines = ["HailOpen1","HailOpen2","OnScreen" ]
	rHailLines = App.g_kSystemWrapper.GetRandomNumber(len(HailLines))

	# Get Helm character.
	pSet = App.g_kSetManager.GetSet("bridge")
	pHelm = App.CharacterClass_GetObject(pSet, "Helm")

	# Play dialogue.	
	# Setup a sequence.
	pSeq = App.TGSequence_Create()
	pSeq.AppendAction(App.CharacterAction_Create(pHelm, App.CharacterAction.AT_PLAY_ANIMATION, "PushingButtons"))
	pLineAction = App.CharacterAction_Create(pHelm, App.CharacterAction.AT_SAY_LINE, HailLines[rHailLines],	None, 0, pHelm.GetDatabase())
	pSeq.AppendAction(pLineAction)


	rBth = App.g_kSystemWrapper.GetRandomNumber(2)

	if(rBth == 0):
		pSeq.AppendAction(App.TGSoundAction_Create("Borg Sound2"))
	if(rBth == 1):
		pSeq.AppendAction(App.TGSoundAction_Create("Borg Sound3"))	

	pSeq.Play()
	return 1


def DialogoLocutus1():
	# Get Player
	pPlayer = MissionLib.GetPlayer()
	if pPlayer is None:
		return 0

	HailLines = ["HailOpen1","HailOpen2","OnScreen" ]
	rHailLines = App.g_kSystemWrapper.GetRandomNumber(len(HailLines))

	# Get Helm character.
	pSet = App.g_kSetManager.GetSet("bridge")
	pHelm = App.CharacterClass_GetObject(pSet, "Helm")

	# Play dialogue.
	# Setup a sequence.
	pSeq = App.TGSequence_Create()
	pSeq.AppendAction(App.CharacterAction_Create(pHelm, App.CharacterAction.AT_PLAY_ANIMATION, "PushingButtons"))
	pLineAction = App.CharacterAction_Create(pHelm, App.CharacterAction.AT_SAY_LINE, HailLines[rHailLines],	None, 0, pHelm.GetDatabase())
	pSeq.AppendAction(pLineAction)


	rBth = App.g_kSystemWrapper.GetRandomNumber(2)

	if(rBth == 0):
		pSeq.AppendAction(App.TGSoundAction_Create("Borg Sound2"))

	if(rBth == 1):
		pSeq.AppendAction(App.TGSoundAction_Create("Borg Sound3"))

	pSeq.Play()
	return 1



# vDiff = pTarget.GetWorldLocation()

#pImpulseEngines = pShipTarget.GetImpulseEngineSubsystem()
	#if pImpulseEngines:
		#fSpeed = pImpulseEngines.GetCurMaxSpeed()

# If we're in-system warping, don't check for collisions, because
		# the in-system warp check already does that.
		#if pShip.IsDoingInSystemWarp():


		#pShip.GetVelocityTG()
		#pShip.GetAccelerationTG()

		# If he's talking right now, don't add another line.
		#if pFelix.IsSpeaking():
			#return

		# Reset all subsystems to normal power for the ship's alert
		# status.
		#pShip.SetAlertLevel(pShip.GetAlertLevel())

		# Get ship's shields
	        #pShields = pShip.GetShields()

	        #if (pShields != None):

		# If the ship is dead or dying, stop the sequence.
	        #if pShip.IsDead()  or  pShip.IsDying():

                #pTarget = App.ObjectClass_Cast(pEvent.GetSource())
	        #if pEnemyGroup.IsNameInGroup(pTarget.GetName()):






