import App
import MissionLib

################################################################################
##	CreatePicard()
##
##	Adds Picard to the bridge and creates his menu buttons.
##
##	Args:	None
##
##	Return:	None
################################################################################
def CreatePicard():
	# Get the bridge
	pBridge = App.g_kSetManager.GetSet("bridge")
	pBridgeSet = App.BridgeSet_Cast(pBridge)
	# Import Picard and add him to the bridge
	import Bridge.Characters.Saffi
	import Bridge.Characters.Kiska
	pSaffi = App.CharacterClass_GetObject(pBridge, "XO")
	pKiska = App.CharacterClass_GetObject(pBridge, "Helm")
	import Bridge.Characters.Picard
	pPicard = App.CharacterClass_GetObject(pBridge, "Picard")


	import Bridge.Characters.CommonAnimations

	if not (pPicard):
		pPicard = Bridge.Characters.Picard.CreateCharacter(pBridge)
		Bridge.Characters.Picard.ConfigureForGalaxy(pPicard)
		rpEntry = App.g_kSystemWrapper.GetRandomNumber(5)
		if (rpEntry == 0 or rpEntry == 1):
			if (pKiska.GetLocation() == "DBHelm"):
				pPicard.SetLocation("DBL1M")
				pSaffi.SetLocation("DBL1M")
				PicardWalkOn()
			else:
				pPicard.SetLocation("DBGuest")
				pSaffi.SetLocation("DBCommander")
				DBriefing()
		if (rpEntry == 2):
			if (pKiska.GetLocation() == "DBHelm"):
				pPicard.SetLocation("DBGuest")
				DBriefing()
				pSaffi.SetLocation("DBL1M")
				pSaffi.MoveTo("C")
			else:
				pPicard.SetLocation("DBGuest")
				pSaffi.SetLocation("DBCommander")
		if (rpEntry == 3):
			if (pKiska.GetLocation() == "DBHelm"):
				pCamera = App.ZoomCameraObjectClass_GetObject(pBridgeSet, "maincamera")
				pCamera.PopCameraMode("GalaxyBridgeCaptain")
				pCaptainStand = Bridge.Characters.CommonAnimations.DBCaptainStand(pCamera)
				pCaptainSit = Bridge.Characters.CommonAnimations.DBCaptainSit(pCamera)
				pCaptForward = App.TGScriptAction_Create(__name__, "BridgeCameraForward")
				pSaffi.SetLocation("DBCommander")
				pSequence = App.TGSequence_Create()
				pPicard.SetLocation("DBL1M")
		#		pPicard.SetLocation("DBGuest")
		#		pPicard.MoveTo("L1")
				pSequence.AppendAction(pCaptainStand)
				pPicard.MoveTo("P1")
		#		pPicard.SetLocation("DBGuestC1")
		#		pPicard.MoveTo("P")
		#		pPicard.MoveTo("C1")
				pPicard.SetRandomAnimationEnabled(0)
				pPicard.PlayAnimation("DBGuest1ToP")
				pPicard.SetRandomAnimationEnabled(1)
				pSequence.AddAction(pCaptForward, pCaptainStand, 13.0)
				pSequence.AddAction(pCaptainSit, pCaptForward, 1.5)
				pSequence.Play()
			else:
				pPicard.SetLocation("DBGuest")
				pSaffi.SetLocation("DBCommander")
				DBriefing()
		if (rpEntry == 4):
			if (pKiska.GetLocation() == "DBHelm"):
				pPicard.SetLocation("DBGuest")
				pSaffi.SetLocation("DBL1M")
				pSaffi.MoveTo("C")
			else:
				pPicard.SetLocation("DBGuest")
				pSaffi.SetLocation("DBCommander")


################################################################################
##	CreateData()
##
##	Adds Data to the bridge and creates his menu buttons.
##
##	Args:	None
##
##	Return:	None
################################################################################
def CreateData():
	# Get the bridge
	pBridge = App.g_kSetManager.GetSet("bridge")
	pBridgeSet = App.BridgeSet_Cast(pBridge)

	# Import Data and add him to the bridge
	import Bridge.Characters.Data
	import Bridge.Characters.Saffi
	import Bridge.Characters.Kiska
	pData = App.CharacterClass_GetObject(pBridge, "Data")
	pSaffi = App.CharacterClass_GetObject(pBridge, "XO")
	pKiska = App.CharacterClass_GetObject(pBridge, "Helm")

	if not (pData):
		pData = Bridge.Characters.Data.CreateCharacter(pBridge)
		rEntry = App.g_kSystemWrapper.GetRandomNumber(4)
		if (pBridgeSet.GetConfig() == 'SovereignBridge'):
			Bridge.Characters.Data.ConfigureForSovereign(pData)
			if (rEntry == 0):
				pData.SetLocation("EBGuest")
			if (rEntry == 1):
				pData.SetLocation("EBGuest")
				EBriefing()
			if (rEntry == 2):
				pData.SetLocation("EBL1M")
				EBriefing()
				pData.MoveTo("X")
			if (rEntry == 3):
				pData.SetLocation("EBL1M")
				pData.MoveTo("X")
#				pData.MoveTo("L1")
#				pData.MoveTo("X2")
#				pData.SetRandomAnimationEnabled(0)
#				pData.PlayAnimation("EBGuest2ToX")
#				pData.SetRandomAnimationEnabled(1)
		if (pBridgeSet.GetConfig() == 'GalaxyBridge'):
			Bridge.Characters.Data.ConfigureForGalaxy(pData)
			rpEntry = App.g_kSystemWrapper.GetRandomNumber(2)
			if (rpEntry == 0):
				if (pKiska.GetLocation() == "DBHelm"):
					pData.SetLocation("DBGuest")
					DBriefing()
					pSaffi.SetLocation("DBL1M")
					pSaffi.MoveTo("C")
				else:
					pData.SetLocation("DBGuest")
					pSaffi.SetLocation("DBCommander")
					DBriefing()
			if (rpEntry == 1):
				if (pKiska.GetLocation() == "DBHelm"):
					pData.SetLocation("DBGuest")
					pSaffi.SetLocation("DBL1M")
					pSaffi.MoveTo("C")
				else:
					pData.SetLocation("DBGuest")
					pSaffi.SetLocation("DBCommander")


################################################################################
##	DBriefing()
##
##	Starts a cutscene which does D bridge walk on,
##
##	Args:	None
##
##	Return:	None
################################################################################
def DBriefing():
	
	# Position camera at lift.
	pBridge = App.BridgeSet_Cast( App.g_kSetManager.GetSet("bridge") )
	pCamera = App.ZoomCameraObjectClass_GetObject(pBridge, "maincamera")

	# Create the action that calls the walk on sequence.
	import Bridge.Characters.CommonAnimations
	pWalkSequence = Bridge.Characters.CommonAnimations.WalkCameraToCaptOnD(pCamera)

	pSequence = App.TGSequence_Create()

	pSequence.AddAction(pWalkSequence)

	pSequence.Play()




################################################################################
##	EBriefing()
##
##	Starts a cutscene which does E bridge walk on,
##
##	Args:	None
##
##	Return:	None
################################################################################
def EBriefing():
	
	# Position camera at lift.
	pBridge = App.BridgeSet_Cast( App.g_kSetManager.GetSet("bridge") )
	pCamera = App.ZoomCameraObjectClass_GetObject(pBridge, "maincamera")

	# Create the action that calls the walk on sequence.
	import Bridge.Characters.CommonAnimations
	pWalkSequence = Bridge.Characters.CommonAnimations.WalkCameraToCaptOnE(pCamera)

	pSequence = App.TGSequence_Create()

	pSequence.AddAction(pWalkSequence)

	pSequence.Play()




################################################################################
##	PicardWalkOn()
##
##	Plays sequence of Picard and Saffi walking on the bridge.
##
##
################################################################################
def PicardWalkOn():

	pMission = MissionLib.GetMission()
	pMissionDatabase = pMission.SetDatabase("data/TGL/Maelstrom/Episode 1/E1M1.tgl")

	# Get the bridge Camera and remove the standard Camera mode.
	pBridge = App.g_kSetManager.GetSet("bridge")
	pBridgeSet = App.BridgeSet_Cast(pBridge)
	pSaffi = App.CharacterClass_GetObject(pBridge, "XO")
	pPicard = App.CharacterClass_GetObject(pBridge, "Picard")
	pCamera = App.ZoomCameraObjectClass_GetObject(pBridgeSet, "maincamera")
	pCamera.PopCameraMode("GalaxyBridgeCaptain")

	# Create the action that does the captain stand.
	import Bridge.Characters.CommonAnimations
	pCaptainStand = Bridge.Characters.CommonAnimations.DBCaptainStand(pCamera)
	pCaptainSit = Bridge.Characters.CommonAnimations.DBCaptainSit(pCamera)

	pSequence = App.TGSequence_Create()

	pPicardWalkToP1 = App.CharacterAction_Create(pPicard, App.CharacterAction.AT_MOVE, "P1")
	pPicardEntrance1 = App.CharacterAction_Create(pPicard, App.CharacterAction.AT_SAY_LINE, "E1M1Entrance1", None, 0, pMissionDatabase)
	pSaffiIntro2 = App.CharacterAction_Create(pSaffi, App.CharacterAction.AT_SAY_LINE, "E1M1SaffiIntro2", None, 0, pMissionDatabase)
	pSaffiWalkToC2 = App.CharacterAction_Create(pSaffi, App.CharacterAction.AT_MOVE, "C2")

	pSaffiWatch = App.CharacterAction_Create(pSaffi, App.CharacterAction.AT_WATCH_ME)
	pSaffiSitToC = App.CharacterAction_Create(pSaffi, App.CharacterAction.AT_MOVE, "C")
	pSaffiSWatch = App.CharacterAction_Create(pSaffi, App.CharacterAction.AT_STOP_WATCHING_ME)

	pPicardWatch = App.CharacterAction_Create(pPicard, App.CharacterAction.AT_WATCH_ME)
	pPicardSitToP = App.CharacterAction_Create(pPicard, App.CharacterAction.AT_MOVE, "P")
	pPicardTurn = App.CharacterAction_Create(pPicard, App.CharacterAction.AT_TURN, "Captain")
	pPicardSWatch = App.CharacterAction_Create(pPicard, App.CharacterAction.AT_STOP_WATCHING_ME)
	pCaptForward = App.TGScriptAction_Create(__name__, "BridgeCameraForward")

	pSequence.AppendAction(pCaptainStand)
	pSequence.AppendAction(pPicardWalkToP1)
	pSequence.AddAction(pSaffiWalkToC2, pCaptainStand, 0.7)
	pSequence.AddAction(pPicardEntrance1, pCaptainStand)
	pSequence.AddAction(pSaffiIntro2, pPicardEntrance1)

	pSequence.AddAction(pPicardSitToP, pSaffiIntro2)
	pSequence.AddAction(pPicardTurn, pPicardSitToP)
	pSequence.AddAction(pSaffiSitToC, pPicardTurn)
	pSequence.AddAction(pCaptForward, pSaffiSitToC)
	pSequence.AddAction(pCaptainSit, pCaptForward, 1.5)


	pSequence.Play()



###############################################################################
#	BridgeCameraForward
#	
#	Helper function for the warp sequence.  Get tbe main bridge
#	camera, and set it to look forward.
#	
#	Args:	pAction - the action
#	
#	Return:	zero for end
###############################################################################
def BridgeCameraForward(pAction):
	# Get the bridge...
	pSet = App.g_kSetManager.GetSet("bridge")
	if pSet:
		# Get the main camera for the captain's view.
		pCamera = App.ZoomCameraObjectClass_Cast( pSet.GetCamera("maincamera") )
		if pCamera:
			# Tell the camera to look forward.
			pCamera.LookForward()

	return 0

