import App
import loadspacehelper
import MissionLib


gSystem = []
gBridge = ''
gPlayer = []
gPlayerLoc = []
gEnemy = []
gEnemyLoc = []
gEnemyStarbases = []
gEnStLoc = []
gFriendly = []
gFriendlyLoc = []
gFriendlyStarbases = []
gFrStLoc = []
gNeutral = []
gNeutralLoc = []
gNeutralStarbases = []
gNeStLoc = []

global pTimer
pEnemies = None
pFriendlies = None
pNeutrals = None
g_pDatabase = None
g_pMission = None


g_pKiska = None
g_pFelix = None
g_pSaffi = None
g_pMiguel = None
g_pBrex = None


def PreLoadAssets(pMission):
	InitLists()

	loadspacehelper.PreloadShip(gPlayer[0], 1)
	for pEnemy in gEnemy:
		loadspacehelper.PreloadShip(pEnemy[0], 1)
	for pFriendly in gFriendly:
		loadspacehelper.PreloadShip(pFriendly[0], 1)

def Initialize(pMission):
	global pEnemies
	pEnemies = pMission.GetEnemyGroup()
	global pFriendlies
	pFriendlies = pMission.GetFriendlyGroup()
	global pNeutrals
	pNeutrals = pMission.GetNeutralGroup()
	global g_pDatabase
	g_pDatabase = App.g_kLocalizationManager.Load('data/TGL/Bridge Menus.tgl')
	global g_pMission
	g_pMission = pMission

	CreateStartingRegions()
    # Specify (and load if necessary) our bridge

	import LoadBridge
	LoadBridge.Load(gBridge + 'Bridge')

	App.g_kUtopiaModule.SetTimeScale(0.70)

    #Init the Characters
	InitializeCrewPointers()
	QualePersonaggio()

	AddSystemMenus()

	CreateStartingObjects(pMission)

	pPlayer = MissionLib.GetPlayer()


	App.g_kUtopiaModule.SetFrameRate(85)
	App.g_kUtopiaModule.SetCaptainName('Soran')




def Terminate(pMission):
	if (g_pDatabase != None):
		App.g_kLocalizationManager.Unload(g_pDatabase)


def InitLists():
	global gSystem, gBridge, gPlayer, gPlayerLoc, gEnemy, gEnemyLoc
	global gEnemyStarbases, gEnStLoc, gFriendly, gFriendlyLoc, gFriendlyStarbases
	global gFrStLoc, gNeutral, gNeutralLoc, gNeutralStarbases, gNeStLoc

	import QBSetup
	gSystem                =  QBSetup.gSystem           
	gBridge                =  QBSetup.gBridge           
	gPlayer                =  QBSetup.gPlayer           
	gPlayerLoc             =  QBSetup.gPlayerLoc        
	gEnemy                 =  QBSetup.gEnemy            
	gEnemyLoc              =  QBSetup.gEnemyLoc
	gEnemyStarbases        =  QBSetup.gEnemyStarbases   
	gEnStLoc               =  QBSetup.gEnStLoc          
	gFriendly              =  QBSetup.gFriendly         
	gFriendlyLoc           =  QBSetup.gFriendlyLoc      
	gFriendlyStarbases     =  QBSetup.gFriendlyStarbases
	gFrStLoc               =  QBSetup.gFrStLoc          
	gNeutral               =  QBSetup.gNeutral         
	gNeutralLoc            =  QBSetup.gNeutralLoc      
	gNeutralStarbases      =  QBSetup.gNeutralStarbases
	gNeStLoc               =  QBSetup.gNeStLoc          


def InitializeCrewPointers():
	pBridge = App.g_kSetManager.GetSet('bridge')

    # Get the Characters
	global g_pKiska
	g_pKiska = App.CharacterClass_GetObject(pBridge, 'Helm')

	global g_pFelix
	g_pFelix = App.CharacterClass_GetObject(pBridge, 'Tactical')

	global g_pSaffi
	g_pSaffi = App.CharacterClass_GetObject(pBridge, 'XO')

	global g_pMiguel
	g_pMiguel = App.CharacterClass_GetObject(pBridge, 'Science')

	global g_pBrex
	g_pBrex = App.CharacterClass_GetObject(pBridge, 'Engineer')

	g_pKiska.SetInitiative(1)
	g_pFelix.SetInitiative(1)
	g_pSaffi.SetInitiative(1)
	g_pMiguel.SetInitiative(1)
	g_pBrex.SetInitiative(1)
	RandomEnter()




def AddSystemMenus():
	for system in gSystem:
		if (system[0] == 'Starbase12'):
			import Systems.Starbase12.Starbase
			pMenu = Systems.Starbase12.Starbase.CreateMenus()
		elif (system[0] == 'DryDock'):
			import Systems.DryDock.DryDockSystem
			pMenu = Systems.DryDock.DryDockSystem.CreateMenus()
		elif (system[0] == 'QuickBattle'):
			import Systems.QuickBattle.QuickBattleSystem
			pMenu = Systems.QuickBattle.QuickBattleSystem.CreateMenus()
		else:
			pModule = __import__('Systems.' + system[0] + '.' + system[0])
			pMenu = pModule.CreateMenus()
		if (system[2] != ''):
			pMenu.SetEpisodeName(system[2])


def CreateStartingObjects(pMission):
	pQBSet = App.g_kSetManager.GetSet(gPlayer[2])
	pPlayer = MissionLib.CreatePlayerShip(gPlayer[0], pQBSet, gPlayer[1], '')
	TranslateShip(pPlayer, gPlayerLoc[0], gPlayerLoc[1], gPlayerLoc[2])

	AddShips()

	pPlayer = MissionLib.GetPlayer()
	if (pPlayer is None):
		return 

def AddShips():
	import QuickBattleAI
	import QuickBattleFriendlyAI
	import StarbaseAI
	import StarbaseFriendlyAI

	pEnemies.RemoveAllNames()
	pFriendlies.RemoveAllNames()
	pNeutrals.RemoveAllNames()

	for pEnemy in gEnemy:
		pEnemies.AddName(pEnemy[1])
	for pEnemy in gEnemyStarbases:
		pEnemies.AddName(pEnemy[1])

		pFriendlies.AddName(gPlayer[1])
	for pFriend in gFriendly:
		pFriendlies.AddName(pFriend[1])
		MissionLib.AddCommandableShip(pFriend[1])
	for pFriend in gFriendlyStarbases:
		pFriendlies.AddName(pFriend[1])

	for pNeutral in (gNeutral+gNeutralStarbases):
		pNeutrals.AddName(pNeutral[1])


	i = 0
	for pEnemy in gEnemy:
		pSet = App.g_kSetManager.GetSet(pEnemy[2])
		pEnemyShip = loadspacehelper.CreateShip(pEnemy[0], pSet, pEnemy[1], '')
		TranslateShip(pEnemyShip, gEnemyLoc[i][0], gEnemyLoc[i][1], gEnemyLoc[i][2])
		if (pEnemy[4] == ''):
			pEnemyShip.SetAI(QuickBattleAI.CreateAI(pEnemyShip, pEnemy[5], pEnemy[3]))
		else:
			pModule = __import__(pEnemy[4])
			ai = apply(pModule.CreateAI, (pEnemyShip,))
			pEnemyShip.SetAI(ai)
		i = i + 1

	i = 0
	for pEnemy in gEnemyStarbases:
		pSet = App.g_kSetManager.GetSet(pEnemy[2])
		pEnemyShip = loadspacehelper.CreateShip(pEnemy[0], pSet, pEnemy[1], '')
		TranslateShip(pEnemyShip, gEnStLoc[i][0], gEnStLoc[i][1], gEnStLoc[i][2])
		if (pEnemy[3] == ''):
			pEnemyShip.SetAI(StarbaseAI.CreateAI(pEnemyShip))
		else:
			pModule = __import__(pEnemy[3])
			ai = apply(pModule.CreateAI, (pEnemyShip,))
			pEnemyShip.SetAI(ai)
		i = i + 1

	i = 0
	for pFriend in gFriendly:
		pSet = App.g_kSetManager.GetSet(pFriend[2])
		pFriendlyShip = loadspacehelper.CreateShip(pFriend[0], pSet, pFriend[1], '')
		TranslateShip(pFriendlyShip, gFriendlyLoc[i][0], gFriendlyLoc[i][1], gFriendlyLoc[i][2])
		if (pFriend[4] == ''):
			pFriendlyShip.SetAI(QuickBattleFriendlyAI.CreateAI(pFriendlyShip, pFriend[5], pFriend[3]))
		else:
			pModule = __import__(pFriend[4])
			ai = apply(pModule.CreateAI, (pFriendlyShip,))
			pFriendlyShip.SetAI(ai)
		i = i + 1

	i = 0
	for pFriend in gFriendlyStarbases:
		pSet = App.g_kSetManager.GetSet(pFriend[2])
		pFriendlyShip = loadspacehelper.CreateShip(pFriend[0], pSet, pFriend[1], '')
		TranslateShip(pFriendlyShip, gFrStLoc[i][0], gFrStLoc[i][1], gFrStLoc[i][2])
		if (pFriend[3] == ''):
			pFriendlyShip.SetAI(StarbaseFriendlyAI.CreateAI(pFriendlyShip))
		else:
			pModule = __import__(pFriend[3])
			ai = apply(pModule.CreateAI, (pFriendlyShip,))
			pFriendlyShip.SetAI(ai)
		i = i + 1

	i = 0
	for pNeutral in gNeutral:
		pSet = App.g_kSetManager.GetSet(pNeutral[2])
		pNeutralShip = loadspacehelper.CreateShip(pNeutral[0], pSet, pNeutral[1], '')
		TranslateShip(pNeutralShip, gNeutralLoc[i][0], gNeutralLoc[i][1], gNeutralLoc[i][2])
		if (pNeutral[4] != ''):
			pModule = __import__(pNeutral[4])
			ai = apply(pModule.CreateAI, (pNeutralShip,))
			pNeutralShip.SetAI(ai)
		i = i + 1

	i = 0
	for pNeutral in gNeutralStarbases:
		pSet = App.g_kSetManager.GetSet(pNeutral[2])
		pNeutralShip = loadspacehelper.CreateShip(pNeutral[0], pSet, pNeutral[1], '')
		TranslateShip(pNeutralShip, gNeStLoc[i][0], gNeStLoc[i][1], gNeStLoc[i][2])
		if (pNeutral[3] != ''):
			pModule = __import__(pNeutral[3])
			ai = apply(pModule.CreateAI, (pNeutralShip,))
			pNeutralShip.SetAI(ai)
		i = i + 1



def TranslateShip(pShip, x, y, z):
	pPlayer = App.Game_GetCurrentPlayer()

	if (x == y == z == 0):
		if (pShip.GetName() != pPlayer.GetName()):
			PlaceShipRandomly(pShip)
	else:
		p = App.TGPoint3()
		p.SetX(x)
		p.SetY(y)
		p.SetZ(z)
		pShip.SetTranslate(p)


def CreateStartingRegions():
	for system in gSystem:
		if (App.g_kSetManager.GetSet(system[1]) is None):
			MissionLib.SetupSpaceSet('Systems.' + system[0] + '.' + system[1])


def PlaceShipRandomly(pShip):
	pSet = pShip.GetContainingSet()

	vLocation = pShip.GetWorldLocation()
	vForward = pShip.GetWorldForwardTG()
	vForward.Scale(pShip.GetRadius() + pShip.GetRadius() + 200.0)

	kPoint = App.TGPoint3()
	ChooseNewLocation(vLocation, vForward)
	kPoint.Set(vLocation)
	kPoint.Add(vForward)

	fRadius = pShip.GetRadius () * 2.0

	while pSet.IsLocationEmptyTG(kPoint, fRadius, 1) == 0:
		ChooseNewLocation(vLocation, vForward)
		kPoint.Set(vLocation)
		kPoint.Add(vForward)

	pShip.SetTranslate(kPoint)

def ChooseNewLocation(vOrigin, vOffset):
	# Add some random amount to vOffset
	fUnitRandom = (App.g_kSystemWrapper.GetRandomNumber(10001) - 5000.0) / 5000.0
	fUnitRandom = fUnitRandom * (App.g_kSystemWrapper.GetRandomNumber (1000) + 750)

	vOffset.SetX( vOffset.GetX() + fUnitRandom )


	fUnitRandom = (App.g_kSystemWrapper.GetRandomNumber(10001) - 5000.0) / 5000.0
	fUnitRandom = fUnitRandom * (App.g_kSystemWrapper.GetRandomNumber (1000) + 750)

	vOffset.SetY( vOffset.GetY() + fUnitRandom )

	fUnitRandom = (App.g_kSystemWrapper.GetRandomNumber(10001) - 5000.0) / 5000.0
	fUnitRandom = fUnitRandom * (App.g_kSystemWrapper.GetRandomNumber (1000) + 750)

	vOffset.SetZ( vOffset.GetZ() + fUnitRandom )

	return 0

def QualePersonaggio():
	import Personaggi
	rEntry = App.g_kSystemWrapper.GetRandomNumber(4)
	if (gBridge == 'Galaxy'):
		if (rEntry == 0 or rEntry == 1 or rEntry == 2):
			Personaggi.CreatePicard()
		if (rEntry == 3):
			Personaggi.CreateData()
	if (gBridge == 'Sovereign'):
		Personaggi.CreateData()

def RandomEnter():
	rEntry = App.g_kSystemWrapper.GetRandomNumber(3)
	rsEntry = App.g_kSystemWrapper.GetRandomNumber(7)
	rSaffi = App.g_kSystemWrapper.GetRandomNumber(3)

	if (gBridge == 'Galaxy'):
#		g_pFelix.MoveTo("L1")
		if (rEntry == 0):
			g_pKiska.SetLocation("DBL1M")
			g_pKiska.MoveTo("H")
		if (rEntry == 1):
			g_pMiguel.SetLocation("DBL1S")
			g_pMiguel.MoveTo("S")
		if (rEntry == 2):
			g_pBrex.SetLocation("DBL1S")
			g_pBrex.MoveTo("E")

	if (gBridge == 'Sovereign'):
		if (rSaffi == 0):
			g_pSaffi.SetLocation("EBCommander1")
			g_pSaffi.MoveTo("C")
			g_pFelix.SetLocation("EBL1L")
		if (rSaffi == 1 or rSaffi == 2):
			if (rsEntry == 0):
				g_pFelix.SetLocation("EBL1L")
			if (rsEntry == 1):
				g_pKiska.SetLocation("EBL1M")
				g_pKiska.MoveTo("H")
				g_pFelix.SetLocation("EBL1L")
			if (rsEntry == 2):
				g_pFelix.SetLocation("EBL1L")
				g_pMiguel.SetLocation("EBL1S")
				g_pMiguel.MoveTo("S")
			if (rsEntry == 3):
				g_pFelix.SetLocation("EBL1L")
				g_pMiguel.SetLocation("EBL1S")
				g_pMiguel.MoveTo("S")
				g_pKiska.SetLocation("EBL1M")
				g_pKiska.MoveTo("H")
			if (rsEntry == 4):
				g_pFelix.SetLocation("EBL1L")
				g_pBrex.SetLocation("EBL1S")
				g_pBrex.MoveTo("E")
			if (rsEntry == 5):
				g_pFelix.SetLocation("EBL1L")
				g_pKiska.SetLocation("EBL1M")
				g_pKiska.MoveTo("H")
				g_pBrex.SetLocation("EBL1S")
				g_pBrex.MoveTo("E")
			if (rsEntry == 6):
				g_pFelix.SetLocation("EBL1L")
				g_pMiguel.SetLocation("EBL1S")
				g_pMiguel.MoveTo("S")
				g_pBrex.SetLocation("EBL1S")
				g_pBrex.MoveTo("E")


