import App
import QuickBattle

def CreateAI(pShip, aiLevel, warp):
    import AI.Compound.BasicAttack
    pAttack = AI.Compound.BasicAttack.CreateAI(pShip, App.ObjectGroup_FromModule('Custom.QuickBattleGame.QuickBattle', 'pFriendlies'), Difficulty=aiLevel, FollowTargetThroughWarp=warp, UseCloaking=1)
    pTurn = App.PlainAI_Create(pShip, 'Turn')
    pTurn.SetScriptModule('ManeuverLoop')
    pTurn.SetInterruptable(1)
    pScript = pTurn.GetScriptInstance()
    pScript.SetLoopFraction(0.25)
    pScript.SetTurnAxis(App.TGPoint3_GetModelLeft())
    pTurn_2 = App.PlainAI_Create(pShip, 'Turn_2')
    pTurn_2.SetScriptModule('ManeuverLoop')
    pTurn_2.SetInterruptable(1)
    pScript = pTurn_2.GetScriptInstance()
    pScript.SetLoopFraction(0.25)
    pScript.SetTurnAxis(App.TGPoint3_GetModelRight())
    pTurn_3 = App.PlainAI_Create(pShip, 'Turn_3')
    pTurn_3.SetScriptModule('ManeuverLoop')
    pTurn_3.SetInterruptable(1)
    pScript = pTurn_3.GetScriptInstance()
    pScript.SetLoopFraction(0.25)
    pScript.SetTurnAxis(App.TGPoint3_GetModelUp())
    pTurn_4 = App.PlainAI_Create(pShip, 'Turn_4')
    pTurn_4.SetScriptModule('ManeuverLoop')
    pTurn_4.SetInterruptable(1)
    pScript = pTurn_4.GetScriptInstance()
    pScript.SetLoopFraction(0.25)
    pScript.SetTurnAxis(App.TGPoint3_GetModelDown())
    pFlyPointlessly = App.RandomAI_Create(pShip, 'FlyPointlessly')
    pFlyPointlessly.SetInterruptable(1)
    pFlyPointlessly.AddAI(pTurn)
    pFlyPointlessly.AddAI(pTurn_2)
    pFlyPointlessly.AddAI(pTurn_3)
    pFlyPointlessly.AddAI(pTurn_4)
    pRepeatForever = App.SequenceAI_Create(pShip, 'RepeatForever')
    pRepeatForever.SetInterruptable(1)
    pRepeatForever.SetLoopCount(-1)
    pRepeatForever.SetResetIfInterrupted(1)
    pRepeatForever.SetDoubleCheckAllDone(1)
    pRepeatForever.SetSkipDormant(0)
    pRepeatForever.AddAI(pFlyPointlessly)
    pPriorityList = App.PriorityListAI_Create(pShip, 'PriorityList')
    pPriorityList.SetInterruptable(1)
    pPriorityList.AddAI(pAttack, 1)
    pPriorityList.AddAI(pRepeatForever, 2)
    import AI.Preprocessors
    pScript = AI.Preprocessors.AvoidObstacles()
    pAvoidObstacles = App.PreprocessingAI_Create(pShip, 'AvoidObstacles')
    pAvoidObstacles.SetInterruptable(1)
    pAvoidObstacles.SetPreprocessingMethod(pScript, 'Update')
    pAvoidObstacles.SetContainedAI(pPriorityList)
    pTimePassed = App.ConditionScript_Create('Conditions.ConditionTimer', 'ConditionTimer', 7, 0)

    def EvalFunc(bTimePassed):
        ACTIVE = App.ArtificialIntelligence.US_ACTIVE
        DORMANT = App.ArtificialIntelligence.US_DORMANT
        DONE = App.ArtificialIntelligence.US_DONE
        if bTimePassed:
            return ACTIVE
        return DORMANT

    pWait = App.ConditionalAI_Create(pShip, 'Wait')
    pWait.SetInterruptable(1)
    pWait.SetContainedAI(pAvoidObstacles)
    pWait.AddCondition(pTimePassed)
    pWait.SetEvaluationFunction(EvalFunc)
    return pWait

